;----------------------------------------------------------------------------------
	include		"doorsos.h"
	include		"graphlib.h"
	include		"userlib.h"
	include		"hexlib.h"
	include		"abutils.asm"
	include		"misclib.m"
;----------------------------------------------------------------------------------
	xdef			_ti92plus
	xdef    		_main
	xdef			_comment
;----------------------------------------------------------------------------------

_main:
	jsr			ResetDisp
	move.b		#$ff,exit
Loop:
	jsr			Receive
	jsr			Send
	tst.b			exit
	bne			Loop
	rts


ResetDisp:
	move.l		#1,d6
	move.l		#1,d7
	move.l		#9,d4
	move.l		#1,d5
	DrawBarXY		#0,#0,#239,#127,#1
	Horizontal		#67
	rts
	
Receive:
	ReceiveByte
	tst.b			d1
	beq			RecEnd
	WriteHex		d4,d5,d0,#1
	addq.l		#3,d5
	cmp.w			#31,d5
	beq			incY2
 RecEnd:
	rts
 incY2:
	addq.l		#2,d4
 	move.l		#1,d5
	cmp.l			#17,d4
	beq			ClrS2
	bra			RecEnd
 ClrS2:
	DrawBarXY		#0,#68,#239,#59,#1
	move.l		#9,d4
	move.l		#1,d5
	bra			RecEnd


Send:
	GetKeyCode
	tst.b			d0
	beq			SendEnd
	cmp.w			#264,d0
	beq			LoopEnd
	cmp.w			#265,d0
	beq			Menu
	WriteHex		d6,d7,d0,#1
	addq.l		#3,d7
	cmp.w			#31,d7
	beq			incY1
 SendS:
	SendByte		d0
 SendEnd:
	rts
 incY1:
	addq.l		#2,d6
 	move.l		#1,d7
	cmp.l			#9,d6
	beq			ClrS1
	bra			SendS
 ClrS1:
	DrawBarXY		#0,#0,#239,#64,#1
	move.l		#1,d6
	move.l		#1,d7
	bra			SendS
 LoopEnd:
	move.b		#0,exit
	rts


Menu:
	jsr			doorsos::tx_free
	IntToStr		d0,num
	lea			num,a0
	lea			MenuTx2,a1
	move.b		3(a0),0(a1)
	move.b		4(a0),1(a1)
	move.b		#0,clear
	DrawBox		#35,#30,#170,#80,MenuTit,MenuTxt
	move.w		d0,handle
 MenuLoop:
	idleloop
	cmp.w			#263,d0
	beq			ResetPort
	cmp.w			#264,d0
	bne			MenuLoop
	RestoreScreen	handle
	cmp.b			#$ff,clear
	bne			ExitMenu
	jsr			ResetDisp
 ExitMenu:
	move.w		#265,d0
	bra			SendEnd

ResetPort:
	jsr			doorsos::reset_link
	move.b		#$ff,clear
	bra			MenuLoop
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------

_comment			dc.b 	"HexTerminal by Adrian Bader",0
handle			dc.l	0
clear				dc.b	0
exit				dc.b	0
num				dc.b "000000",0
MenuTit			dc.b "HexTerminal by AnBr_Man@Hotmail.com",0
MenuTxt			dc.b "Free Bytes in Linktransmit",13,"Buffer : "
MenuTx2			dc.b "00"
MenuTx3			dc.b	" Bytes.",13,13,"Press [CLEAR] to reset the",13
				dc.b	"Linkport",13,0
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------

	end
